<script lang="ts" context="module">
export async function load({page}) {
    return {
        props: {
            to: page.query.get('to')
        }
    }
}
</script>
<script lang="ts">
import * as Api from "../api/Api";
import {goto} from "$app/navigation";
import TextInput from "../components/TextInput.svelte";
import PasswordInput from "../components/PasswordInput.svelte";
import Button from "../components/Button.svelte";
import Error from "../components/Error.svelte";
import {sha512} from 'js-sha512';

let usr: string, pwd: string;
let spinner = false, incorrect = false;
export let to: string;
let submitHandler = () => {
    console.log('Trying password with hash: ' + sha512(pwd));
    console.log('To: ' + to);
    spinner = true;
    Api.Auth.login(usr, pwd).then(sess => {
        spinner = false;
        goto('/login-handle?sess=' + sess.sessionID + '&to=' + (to || '/'));
    }).catch(r => {
        console.log(r.response);
        if (r.response.status == 403) {
            incorrect = true;
            spinner = false;
            pwd = "";
        } else {
            goto('/error?from=login&servermsg=' + encodeURIComponent(r.response.data))
        }
    })
}
</script>

<svelte:head>
    <title>Login | AZtendance</title>
</svelte:head>

<form on:submit|preventDefault={submitHandler}>
    <TextInput name="id" label="Username" placeholder="s22400999" bind:value={usr} />
    <PasswordInput name="pwd" label="Password" placeholder="password123" bind:value={pwd} />
    {#if incorrect}
        <br />
        <Error message="Incorrect username or password." />
    {/if}
    {#if !spinner}
        <Button content="Login" theme="primary" onclick={submitHandler}/>
    {:else}
        <p>Loading...</p>
    {/if}
</form>